import { observe } from '@nx-js/observer-util';
import qs from 'qs';
import { debounce, parseQuery as _parseQuery, deepMerge } from './utils';
import { batch } from 'react-easy-state';
var shouldReact = true;
var serializeModelReactions = debounce(0, function (reaction) {
    if (shouldReact) {
        return reaction();
    }
    shouldReact = true;
});
export var routerSetup = function (_a) {
    var model = _a.model, serializeModelToUrl = _a.serializeModelToUrl, deserializeUrlToModel = _a.deserializeUrlToModel, parseQuery = _a.parseQuery, onPopState = _a.onPopState;
    observe(function () {
        var _a = serializeModelToUrl(model), path = _a.path, query = _a.query;
        window.history.pushState(null, path, "/" + path + "?" + qs.stringify(query, {
            arrayFormat: 'indices',
            encodeValuesOnly: true
        }));
    }, { scheduler: serializeModelReactions });
    window.onpopstate = function () {
        shouldReact = false;
        var urlModel = deserializeUrlToModel({
            path: location.pathname.slice(1),
            query: (parseQuery && parseQuery(location.search)) ||
                _parseQuery(location.search)
        });
        batch(function () {
            for (var key in urlModel) {
                deepMerge(model[key])(urlModel[key]);
            }
            if (onPopState) {
                onPopState(model);
            }
        });
    };
};
//# sourceMappingURL=router.js.map