declare type Proposal<A> = {
    type: A;
    payload?: any;
};
declare type Present<A> = (proposal: Proposal<A>) => void;
declare type Reducer<A extends string> = {
    [key in A | 'default']: any;
};
declare type Props<M extends object, A extends string> = {
    model: {
        model: M;
        onModelInit: (model: M) => void;
    };
    reducer: {
        reducer: Reducer<A>;
        onReduce: (proposal: Proposal<A>, model: M) => void;
    };
};
export declare const createStore: <M extends object, A extends string>({ model: { model, onModelInit }, reducer: { reducer, onReduce } }: Props<M, A>) => {
    createIntents: <I>(intents: (present: Present<A>) => I) => I;
    napSetup: <M, I>({ model, intents, naps }: {
        model: M;
        intents: I;
        naps?: ((model: M, intents: I) => void)[];
    }) => void;
    routerSetup: ({ model, serializeModelToUrl, deserializeUrlToModel, parseQuery, onPopState }: {
        model: any;
        serializeModelToUrl: any;
        deserializeUrlToModel: any;
        parseQuery?: any;
        onPopState?: any;
    }) => void;
    model: M;
};
export {};
