import { observe } from '@nx-js/observer-util';
import { debounce } from './utils';

type Props<M, I> = {
	model: M;
	intents: I;
	naps?: ((model: M, intents: I) => void)[];
};

export const napSetup = <M, I>({ model, intents, naps = [] }: Props<M, I>) => {
	for (const nap of naps) {
		createNap(model, intents, nap);
	}
};

function createNap(model, intents, nap) {
	return observe(() => nap(model, intents), { scheduler: debounce(0, reaction => reaction()) });
}
